import es
import cfglib
import playerlib
import popuplib
import gamethread
import services
import votelib
from sqlite3 import dbapi2 as sqlite 

info = es.AddonInfo()
info['name'] = "Donator"
info['basename'] = "donator"
info['version'] = "1.0"
info['author'] = "Undead"
info['url'] = ""
info['description'] = "Special Privileges Toward Donators"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

dcfg = cfglib.AddonCFG(es.getAddonPath("donator") + "/config.cfg")
dadmin = dcfg.cvar('Admin_Plguin', "ma", 'ma = Mani Admin Plugin OR sm = SourceMod Admin Plugin')
dmaps = dcfg.cvar('Map_List', "de_dust2,de_dust,cs_office", 'Map List donators can use to trigger a map vote.')
dtime = dcfg.cvar('Ban_Time', "5", 'How long they are banned when vote banned')
dcfg.write()

auth = services.use('auth')
auth.registerCapability('daccess', auth.POWERUSER)

map_list = map(lambda x: x.strip(), str(dmaps).split(",") )
voteMap = 0
voteKick = 0
voteBan = 0
voteMute = 0

class connection(object):
  def __init__(self,path):
    self.con = sqlite.connect(path)
    self.cur = self.con.cursor()
  def execute(self,sql):
    self.cur.execute(sql)
    self.con.commit()
  def query(self,sql):
    self.cur.execute(sql)
    return self.cur.fetchall()
  def close(self):
    self.con.close()
db = connection(es.getAddonPath('examples/auth/group_auth') + '/es_group_auth.sqldb') 

def utfcode(value):
  """ converts value into utf-8 coded string if it is unicode, otherwise returns the value itself """
  if type(value).__name__ == 'unicode':
    return value.encode('utf-8')
  return value

def convertQuery(result):
  """ converts all unicode strings in a full SQLite query result to utf-8 string objects """
  newresult = list()
  for row in result:
    newrow = [utfcode(item) for item in row]
    newresult.append(newrow)
  return newresult 

def load():
  global dadmin, dmaps, isAuthed
  dcfg.execute()
  if dadmin not in ('ma','sm'):
    es.dbgmsg(0, 'Invalid Admin_Plugin CVAR: %s'%dadmin)
    es.dbgmsg(0, '\'ma\' or \'sm\' Only!')
    es.dbgmsg(0, 'Fix in config.cfg')
    es.unload('donator')
  es.addons.registerSayFilter(sayFilter)
  if not es.exists('saycommand', '!dmenu'):
    es.regsaycmd('!dmenu', 'donator/dmenu_cmd')
  if not es.exists('saycommand', '!donators'):
    es.regsaycmd('!donators', 'donator/donators_cmd')
  dmenu = popuplib.easymenu('dmenu', '_popup_choice', dmenu_select)
  dmenu.settitle("Donator Cmds:")
  dmenu.addoption('1', "Swap Teams")
  dmenu.addoption('2', "Start Vote Kick")
  dmenu.addoption('3', "Start Vote Ban")
  dmenu.addoption('4', "Start Vote Mute")
  dmenu.addoption('5', "Start Map Vote")
  es.dbgmsg(0, 'Map Vote List: %s'%dmaps)
  es.msg('#multi', '#default[#greenDonator#default] by #lightgreenUndead #defaulthas been loaded!')

def unload():
  es.addons.unregisterSayFilter(sayFilter)
  if es.exists('saycommand', '!dmenu'):
    es.unregsaycmd('!dmenu')
  if es.exists('saycommand', '!donators'):
    es.unregsaycmd('!donators')
  if popuplib.exists('dmenu'):
    popuplib.delete('dmenu')
  if popuplib.exists('plist'):
    popuplib.delete('plist')
  if popuplib.exists('plist2'):
    popuplib.delete('plist2')
  if popuplib.exists('plist3'):
    popuplib.delete('plist3')
  if popuplib.exists('mlist'):
    popuplib.delete('mlist')
  es.msg('#multi', '#default[#greenDonator#default] by #lightgreenUndead #defaulthas been unloaded!')

def dmenu_cmd():
  user = es.getcmduserid()
  check_user_auth(user)

def donators_cmd():
  userid = es.getcmduserid()
  users = db.query("SELECT ALL Name FROM vwPlayersGroups WHERE GroupName='Donators'")
  if users:
    donators_menu = popuplib.create('donators_menu')
    donators_menu.addline('Current Donators:')
    for user in users:
      donators_menu.addline(utfcode(user[0]))
    donators_menu.send(userid)
  else:
    es.tell(userid, 'No current Donators at the moment')

def check_user_auth(user):
  if auth.isUseridAuthorized(user, 'daccess'):
    popuplib.send('dmenu', user)
  else: es.tell(user, 'You must be a donator!')

def sayFilter(userid, text, teamonly):
  if auth.isUseridAuthorized(userid, 'daccess'):
    newtext = text
    if newtext[0] == newtext[~0] == '"':
      newtext = newtext[1:~0]
    if not newtext.startswith('!'):
      es.msg('#multi', '#green%s: #default%s' % (es.getplayername(userid), newtext))
      return 0, text, teamonly
  return userid, text, teamonly 

def dmenu_select(userid, choice, popupid):
  if choice == '1':
    team = es.getplayerteam(userid)
    if team == 2:
      es.changeteam(userid,'3')
    elif team == 3:
      es.changeteam(userid,'2')
  elif choice == '2':
    plist = popuplib.easymenu('plist', '_popup_choice', plist_select)
    plist.settitle("Select Player:")
    for players in playerlib.getUseridList('#human'):
      if not auth.isUseridAuthorized(players, 'daccess'):
        plist.addoption(players, es.getplayername(players))
    plist.send(userid)
  elif choice == '3':
    plist2 = popuplib.easymenu('plist2', '_popup_choice', plist2_select)
    plist2.settitle("Select Player:")
    for players in playerlib.getUseridList('#human'):
      if not auth.isUseridAuthorized(players, 'daccess'):
        plist2.addoption(players, es.getplayername(players))
    plist2.send(userid)
  elif choice == '4':
    plist3 = popuplib.easymenu('plist3', '_popup_choice', plist3_select)
    plist3.settitle("Select Player:")
    for players in playerlib.getUseridList('#human'):
      if not auth.isUseridAuthorized(players, 'daccess'):
        plist3.addoption(players, es.getplayername(players))
    plist3.send(userid)
  elif choice == '5':
    mlist = popuplib.easymenu('mlist', '_popup_choice', mlist_select)
    mlist.settitle("Select Map:")
    for maps in map_list:
      mlist.addoption(maps, maps)
    mlist.send(userid)

def plist_select(userid, choice, popupid):
  global voteKick
  if auth.isUseridAuthorized(userid, 'daccess'):
    voteKick = votelib.create('%s'%choice, voteKick_end, voteKick_submit)
    voteKick.setquestion('Kick %s?'%es.getplayername(choice))
    voteKick.addoption('No')
    voteKick.addoption('Yes')
    voteKick.start(60)

def voteKick_submit(userid, votename, choice, choicename):
  es.msg('Vote Kick %s - %s selected %s'%(es.getplayername(votename), es.getplayername(userid), choicename))

def voteKick_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
  if cancelled:
    es.msg('Kick %s- Cancelled!'%es.getplayername(votename))
  else:
    if winname == 'Yes':
      es.server.queuecmd('kickid %s Vote Kicked'%votename)
      es.msg('Vote Kick %s - Successful due to majority vote!'%es.getplayername(votename))
    else:
      es.msg('Vote Kick %s - Failed due to majority votes!'%es.getplayername(votename))
  voteKick.delete()

def plist2_select(userid, choice, popupid):
  global voteBan
  if auth.isUseridAuthorized(userid, 'daccess'):
    voteBan = votelib.create('%s'%choice, voteBan_end, voteBan_submit)
    voteBan.setquestion('Ban %s?'%es.getplayername(choice))
    voteBan.addoption('No')
    voteBan.addoption('Yes')
    voteBan.start(60)

def voteBan_submit(userid, votename, choice, choicename):
  es.msg('Vote Ban %s - %s selected %s'%(es.getplayername(votename), es.getplayername(userid), choicename))

def voteBan_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
  if cancelled:
    es.msg('Vote Ban %s - Cancelled!'%es.getplayername(votename))
  else:
    if winname == 'Yes':
      es.server.queuecmd('banid %s %s'%(dtime, votename))
      es.msg('Vote Ban %s - Successful due to majority vote!'%es.getplayername(votename))
    else:
      es.msg('Vote Ban %s - Failed due to majority votes!'%es.getplayername(votename))
  voteBan.delete()

def plist3_select(userid, choice, popupid):
  global voteMute
  if auth.isUseridAuthorized(userid, 'daccess'):
    voteMute = votelib.create('%s'%choice, voteMute_end, voteMute_submit)
    voteMute.setquestion('Mute %s?'%es.getplayername(choice))
    voteMute.addoption('No')
    voteMute.addoption('Yes')
    voteMute.start(60)

def voteMute_submit(userid, votename, choice, choicename):
  es.msg('Vote Mute %s - %s selected %s'%(es.getplayername(votename), es.getplayername(userid), choicename))

def voteMute_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
  if cancelled:
    es.msg('Vote Mute %s - Cancelled!'%es.getplayername(votename))
  else:
    if winname == 'Yes':
      es.server.queuecmd('%s_mute %s'%(dadmin,votename))
      es.msg('Vote Mute %s - Successful due to majority vote!'%es.getplayername(votename))
    else:
      es.msg('Vote Mute %s - Failed due to majority votes!'%es.getplayername(votename))
  voteMute.delete()

def mlist_select(userid, choice, popupid):
  global voteMap
  voteMap = votelib.create('%s'%choice, voteMap_end, voteMap_submit)
  voteMap.setquestion('Change Map To: %s'%choice)
  voteMap.addoption('No')
  voteMap.addoption('Yes')
  voteMap.start(60)

def voteMap_submit(userid, votename, choice, choicename):
  es.msg('Vote Map %s - %s selected %s'%(votename, es.getplayername(userid), choicename))

def voteMap_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
  if cancelled:
    es.msg('Vote Map %s - Cancelled!'%votename)
  else:
    if winname == 'Yes':
      es.server.queuecmd('changelevel %s'%votename)
      es.msg('Vote Map %s - Successful due to majority vote!'%votename)
    else:
      es.msg('Vote Map %s - Failed due to majority votes!'%votename)
  voteMap.delete()